﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
'Custom View class 
''#Event: ExampleEvent (Value As Int)
''#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
''#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
''#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
''#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
''#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
''#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.
#DesignerProperty: Key: Hint, DisplayName: Hint label, FieldType: String, DefaultValue: Hint, Description: Hint Label
#DesignerProperty: Key: HintTextColor, DisplayName: Color Hint, FieldType: Color, DefaultValue: 0xFFCCCCCC, Description: Hint Text color
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Panel
	'Private Const DefaultColorConstant As Int = -984833 'ignore
	Private MyEditText As EditText
	Private LabelHint As Label
	Private HintTextSize As Int
	
	Private HintReduce As Boolean = True
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	MyEditText.Initialize("MyEditText")
	LabelHint.Initialize("LabelHint")
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
	
	MyEditText.Text=Lbl.Text
	MyEditText.TextColor= Lbl.TextColor
	MyEditText.TextSize=Lbl.TextSize
	MyEditText.Gravity=Lbl.Gravity
	MyEditText.Typeface=Lbl.Typeface
	MyEditText.Color=Colors.Transparent
	MyEditText.Hint=""
	
	LabelHint.Color=Colors.Transparent
	LabelHint.TextColor=Colors.Gray
	HintTextSize=LabelHint.TextSize
		
	If Props.ContainsKey("Hint") Then LabelHint.Text=Props.Get("Hint") Else	LabelHint.Text=""
	If Props.ContainsKey("HintTextColor") Then LabelHint.TextColor=Props.Get("HintTextColor")
	mBase.AddView(MyEditText,5dip,5dip,mBase.Width-5dip,mBase.Height-5dip)
	mBase.AddView(LabelHint,5dip,5dip,mBase.Width-5dip,mBase.Height-5dip)
	'LabelHint.SetVisibleAnimated(400,(MyEditText.Text.Length>0))
	
	HintReduce=(MyEditText.Text.Length=0)
	HintAnimation((MyEditText.Text.Length>0)) 
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

Public Sub getEditText As EditText
	Return MyEditText
End Sub

Public Sub getHint As Label
	Return LabelHint
End Sub

Public Sub setText(Text As Object)
	MyEditText.Text=Text
	LabelHint.SetVisibleAnimated(400,(MyEditText.Text.Length>0))
End Sub

Private Sub MyEditText_TextChanged (Old As String, New As String)
	HintAnimation(New.Length>0)
End Sub

Private Sub HintAnimation(B As Boolean)
	If B<>HintReduce Then 
		If B Then 
			LabelHint.SetLayout(5dip,10dip,mBase.Width-10dip,mBase.Height-5dip)
			LabelHint.TextSize=HintTextSize
			If mBase.Height>50dip Then
				LabelHint.SetLayoutAnimated(300,0,0,mBase.Width,30dip)
			Else
				LabelHint.SetLayoutAnimated(300,0,0,mBase.Width,mBase.Height*0.6)
			End If
		Else
			LabelHint.SetLayoutAnimated(300,10dip,10dip,mBase.Width-5dip,mBase.Height-5dip)
			LabelHint.TextSize=MyEditText.TextSize
		End If
		
		HintReduce=b
	End If
End Sub